﻿jsx3.util.Logger.getLogger("org.isocat").info("Loading class[org.isocat.gui.DCEditor]");

/**
 * The DC viewer
 * @author Menzo.Windhouwer@mpi.nl
 */
jsx3.lang.Class.defineClass("org.isocat.gui.DCEditor", null, [], function(DCEditor, DCEditor_prototype) { 

	/**
	 * The class logger
	 */
	DCEditor.log = jsx3.util.Logger.getLogger("org.isocat.gui.DCEditor");
	
	/**
	 * The view block of the component
	 */
	DCEditor_prototype.view;
	
	/**
	 * The window of the component
	 */
	DCEditor_prototype.window;
	
	/**
	 * The editor CDF source
	 */
	DCEditor_prototype.cdf;
	
	/**
	 * The DC
	 */
	DCEditor_prototype.dc;
	
	/**
	 * The label
	 */
	DCEditor_prototype.label;

	/**
	 * The save buttons
	 */
	DCEditor_prototype.saveButtonMenu;
	DCEditor_prototype.saveButtonWizard;

	/**
	 * The cancel button
	 */
	DCEditor_prototype.cancelButtonWizard;

	/**
	 * The check button
	 */
	DCEditor_prototype.checkButton;

	/**
	 * The window button
	 */
	DCEditor_prototype.windowButton;

	/**
	 * The view splitter
	 */
	DCEditor_prototype.viewSplitter;

       /**
	 * The check result view
	 */
	DCEditor_prototype.checkView;
	
       /**
	 * The check result viewer
	 */
	DCEditor_prototype.checkResult;
	
	/**
	 * The editor stack
	 */
	DCEditor_prototype.stack;
	
	/**
	 * The adminstrative information
	 */
	DCEditor_prototype.adminInfo;
	
	/**
	 * The descriptive information
	 */
	DCEditor_prototype.descrInfo;
	
	/**
	 * The linguistic information
	 */
	DCEditor_prototype.lingInfo;
	
	/**
	 * Some of the form fields 
	 */
	DCEditor_prototype.identifier;
	DCEditor_prototype.version;
	DCEditor_prototype.type;
	DCEditor_prototype.origin;
	DCEditor_prototype.administrationStatus;
	DCEditor_prototype.registrationStatus;
	DCEditor_prototype.effectiveDate;
	DCEditor_prototype.untilDate;
	DCEditor_prototype.explanations;
	DCEditor_prototype.issues;
	DCEditor_prototype.profiles;
	DCEditor_prototype.dataElementNames;
	DCEditor_prototype.languageMenuLeft;
	DCEditor_prototype.languageMenuRight;
	DCEditor_prototype.languageSectionsSplitter;
	DCEditor_prototype.datatypes;
	DCEditor_prototype.valueDomain;
	DCEditor_prototype.ruleTypeMask;
	DCEditor_prototype.constraints;
	DCEditor_prototype.isA;
	DCEditor_prototype.linguisticMenuLeft;
	DCEditor_prototype.linguisticMenuRight;
	DCEditor_prototype.linguisticSectionsSplitter;
	
	/**
	 * Tabs related to DC types
	 */
	DCEditor_prototype.simpleComplexTabs;
	DCEditor_prototype.closedConstrainedTabs;
	
	/**
	 * language documents
	 */
	DCEditor_prototype.langsLeft;
	DCEditor_prototype.langsRight;
	
	/**
	 * linguistic documents
	 */
	DCEditor_prototype.lingsLeft;
	DCEditor_prototype.lingsRight;
	/**
	 * The change flag
	 */
	DCEditor_prototype.change;
	
	/**
	 * Indentifier check results
	 */
	DCEditor_prototype.identifierCheckInfo;
	
	/**
	 * Type change results
	 */
	DCEditor_prototype.DCType;
	DCEditor_prototype.typeChangeInfo;
	
	/**
	 * Consistency checks
	 */
	DCEditor_prototype.checks;
	
	/**
	 * Add to basket flag
	 */
	DCEditor_prototype.addToBasket;
	
	/**
	 * Constructor
	 */
	DCEditor_prototype.init = function(view) {
		org.isocat.gui.DCEditor.log.info("initialize DC editor["+this+"]");

		this.view = view;
		org.isocat.gui.DCEditor.log.info("- DC editor view["+this.view+"]");
		this.window = null;
		org.isocat.gui.DCEditor.log.info("- DC editor window["+this.window+"]");
		this.label = this.view.getDescendantOfName("label");
		org.isocat.gui.DCEditor.log.info("- DC editor label["+this.label+"]");
		this.cancelButtonWizard = this.view.getDescendantOfName("cancelButtonWizard");
		org.isocat.gui.DCEditor.log.info("- DC editor cancel button (wizard) ["+this.cancelButtonWizard+"]");
		this.saveButtonMenu = this.view.getDescendantOfName("saveButtonMenu");
		org.isocat.gui.DCEditor.log.info("- DC editor save button (menu) ["+this.saveButtonMenu+"]");
		this.saveButtonWizard = this.view.getDescendantOfName("saveButtonWizard");
		org.isocat.gui.DCEditor.log.info("- DC editor save button (wizard) ["+this.saveButtonWizard+"]");
		this.windowButton = null;//this.view.getDescendantOfName("windowButton");
		org.isocat.gui.DCEditor.log.info("- DC editor window button["+this.windowButton+"]");
		this.window = null;
		org.isocat.gui.DCEditor.log.info("- DC editor window["+this.window+"]");
		this.cdf = this.view.getDescendantOfName("cdf");
		org.isocat.gui.DCEditor.log.info("- DC editor cdf source["+this.cdf+"]");
		this.stack = this.view.getDescendantOfName("stackgroup");
		org.isocat.gui.DCEditor.log.info("- DC editor stack["+this.stack+"]");
		this.adminInfo = this.view.getDescendantOfName("administrativeInformation");
		org.isocat.gui.DCEditor.log.info("- DC editor administrative information["+this.adminInfo+"]");
		this.descrInfo = this.view.getDescendantOfName("descriptiveInformation");
		org.isocat.gui.DCEditor.log.info("- DC editor descriptive information["+this.descrInfo+"]");
		this.lingInfo = this.view.getDescendantOfName("linguisticInformation");
		org.isocat.gui.DCEditor.log.info("- DC editor linguistic information["+this.lingInfo+"]");
		this.checkButton = this.view.getDescendantOfName("checkButton");
		org.isocat.gui.DCEditor.log.info("- check button["+this.checkButton+"]");
		this.viewSplitter = this.view.getDescendantOfName("viewSplitter");
		org.isocat.gui.DCEditor.log.info("- view splitter"+this.viewSplitter+"]");
		this.checkView = this.view.getDescendantOfName("CheckResultView");
		org.isocat.gui.DCEditor.log.info("- check result view"+this.checkView+"]");
		this.checkResult = this.view.getDescendantOfName("checkResult");
		org.isocat.gui.DCEditor.log.info("- check result viewer"+this.checkResult+"]");
		
		// get some of the forms fields
		this.identifier           = this.view.getDescendantOfName("identifier");
		this.version              = this.view.getDescendantOfName("version");
		this.type                 = this.view.getDescendantOfName("type");
		this.origin               = this.view.getDescendantOfName("origin");
		this.administrationStatus = this.view.getDescendantOfName("administrationStatus");
		this.registrationStatus   = this.view.getDescendantOfName("registrationStatus");
		this.effectiveDate        = this.view.getDescendantOfName("effectiveDate");
		this.untilDate            = this.view.getDescendantOfName("untilDate");
		this.explanations         = this.view.getDescendantOfName("explanations");
		this.issues               = this.view.getDescendantOfName("issues");
		this.profiles             = this.view.getDescendantOfName("profiles");
		org.isocat.gui.DCEditor.log.info("- DC editor profiles list["+this.profiles+"]");
		this.dataElementNames     = this.view.getDescendantOfName("dataElementNames");
		this.languageMenuLeft     = this.view.getDescendantOfName("languageMenuLeft");
		this.languageMenuRight    = this.view.getDescendantOfName("languageMenuRight");
		this.languageSectionsSplitter = this.view.getDescendantOfName("languageSectionsSplitter");
		org.isocat.gui.DCEditor.log.info("- DC editor language section splitter["+this.languageSectionsSplitter+"]");
		this.languageSectionLeft  = this.languageSectionsSplitter.getChild("left").getChild("LanguageSection").controller;
		this.languageSectionLeft.setEditor(this);
		org.isocat.gui.DCEditor.log.info("- DC editor language section left["+this.languageSectionLeft+"]");
		this.languageSectionRight = this.languageSectionsSplitter.getChild("right").getChild("LanguageSection").controller;
		this.languageSectionRight.setEditor(this);
		org.isocat.gui.DCEditor.log.info("- DC editor language section right["+this.languageSectionRight+"]");
		this.datatypes            = this.view.getDescendantOfName("datatypes");
		this.valueDomain    = this.view.getDescendantOfName("ProfileValueDomainEditor").controller;
		this.ruleTypeMask         = this.view.getDescendantOfName("ruleTypeMask");
		this.constraints          = this.view.getDescendantOfName("constraints");
		this.isA                  = this.view.getDescendantOfName("isA");
		this.linguisticMenuLeft   = this.view.getDescendantOfName("linguisticMenuLeft");
		this.linguisticMenuRight  = this.view.getDescendantOfName("linguisticMenuRight");
		this.linguisticSectionsSplitter = this.view.getDescendantOfName("linguisticSectionsSplitter");
		this.linguisticSectionLeft  = this.linguisticSectionsSplitter.getChild("left").getChild("LinguisticSection").controller;
		this.linguisticSectionLeft.setEditor(this);
		org.isocat.gui.DCEditor.log.info("- DC editor linguistic section left["+this.linguisticSectionLeft+"]");
		this.linguisticSectionRight = this.linguisticSectionsSplitter.getChild("right").getChild("LinguisticSection").controller;
		this.linguisticSectionRight.setEditor(this);
		org.isocat.gui.DCEditor.log.info("- DC editor linguistic section right["+this.linguisticSectionRight+"]");
		
		// get the DC type tabs
		this.simpleComplexTabs = this.view.getDescendantOfName("simpleComplexTabs");
		this.closedConstrainedTabs = this.view.getDescendantOfName("closedConstrainedTabs");
		
		// get the indentifier check info area
		this.identifierCheckInfo  = this.view.getDescendantOfName("identifierCheckInfo");
		this.identifierCheckInfo.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
		
		// get the type change info area
		this.DCType = null;
		this.typeChangeInfo = this.view.getDescendantOfName("typeChangeInfo");
		this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
		
		// reset the active checks counter
		this.checks = new Object();

		// reset the change flag
		this.change = false;
		
		// reset the add to basket flag
		this.addToBasket = false;
		
		// by default the cancel button is invisible
		this.cancelButtonWizard.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
		
		// reset some form fields
		this.identifier.setValue("");
		this.version.setValue("0.0.0");
		this.origin.setValue("");
		this.administrationStatus.setValue("candidate");
		this.registrationStatus.setValue("private");
		this.effectiveDate.setDate(null);
		this.untilDate.setDate(null);
		this.isA.setText("<i>none</i>");

		// make the admin info active
		this.stack.setSelectedIndex(0);
		
		// reset all text/select masks
		var columns = this.view.getDescendantsOfType(jsx3.gui.Matrix.Column,false);
		for (var c=0;c<columns.length;c++) {
			var column = columns[c];
			var masks = column.getDescendantsOfType(jsx3.gui.TextBox,true);
			for (var m=0;m<masks.length;m++) {
				var mask = masks[m];
				mask.setWidth("100%");
			}
			masks = column.getDescendantsOfType(jsx3.gui.Select,true);
			for (var m=0;m<masks.length;m++) {
				var mask = masks[m];
				mask.setWidth("100%");
			}
		}
		
		// load the profiles
		var cacheId = "profiles-"+this.view.getId();
		var profs = org.isocat.loadDynamicCDFDocument(new jsx3.net.URI("http://isocat:8080/isocat/rest/info/profiles.xml"),"Profiles2CDF_xsl",null,cacheId);
		this.profiles.setXMLId(cacheId);
		this.profiles.repaint();
		
		// set the callbacks for the profile value domains editor
		this.valueDomain.setDelCallback(this,this.delValue);
		this.valueDomain.setChangedCallback(this,this.changed);

		// intialize language/linguistic selectors
		var langs = org.isocat.loadDynamicCDFDocument(new jsx3.net.URI("http://isocat:8080/isocat/rest/info/languages.xml"),"Languages2CDF_xsl");
		var cacheId = "language-"+this.view.getId();

		this.langsLeft = langs.cloneDocument();
		this.langsLeft.insertRecord({jsxid:"none", jsxtext:"none", jsxdivider:"1"});
		org.isocat.APP.getCache().setDocument(cacheId+"-left",this.langsLeft);
		this.languageMenuLeft.setXMLId(cacheId+"-left");
		this.languageMenuLeft.setText("Language");
		this.languageMenuLeft.setImage("images/flag.png");
		this.languageMenuLeft.repaint();
		
		this.langsRight = langs.cloneDocument();
		this.langsRight.insertRecord({jsxid:"none", jsxtext:"none", jsxdivider:"1"});
		org.isocat.APP.getCache().setDocument(cacheId+"-right",this.langsRight);
		this.languageMenuRight.setXMLId(cacheId+"-right");
		this.languageMenuRight.setText("Language");
		this.languageMenuRight.setImage("images/flag.png");
		this.languageMenuRight.repaint();
		
		//this.languageSectionsSplitter.setSubcontainer1Pct("100",true);

		langs = org.isocat.loadDynamicCDFDocument(new jsx3.net.URI("http://isocat:8080/isocat/rest/info/languages.xml"),"LinguisticLanguages2CDF_xsl");
		cacheId = "linguistic-"+this.view.getId();
		
		this.lingsLeft = langs.cloneDocument();
		this.lingsLeft.insertRecord({jsxid:"none", jsxtext:"none", jsxdivider:"1"});
		org.isocat.APP.getCache().setDocument(cacheId+"-left",this.lingsLeft);
		this.linguisticMenuLeft.setXMLId(cacheId+"-left");
		this.linguisticMenuLeft.setText("Language");
		this.linguisticMenuLeft.setImage("images/flag.png");
		this.linguisticMenuLeft.repaint();
		
		this.lingsRight = langs.cloneDocument();
		this.lingsRight.insertRecord({jsxid:"none", jsxtext:"none", jsxdivider:"1"});
		org.isocat.APP.getCache().setDocument(cacheId+"-right",this.lingsRight);
		this.linguisticMenuRight.setXMLId(cacheId+"-right");
		this.linguisticMenuRight.setText("Language");
		this.linguisticMenuRight.setImage("images/flag.png");
		this.linguisticMenuRight.repaint();

		// initialize the datatypes
		var cacheId = "datatypes-"+this.view.getId();
		org.isocat.loadDynamicCDFDocument(new jsx3.net.URI("http://isocat:8080/isocat/rest/info/data-types.xml"),"Datatypes2CDF_xsl",null,cacheId);
		this.datatypes.setXMLId(cacheId);

		// initialize the rule types
		var cacheId = "ruletypes-"+this.view.getId();
		var ruleTypes = org.isocat.loadDynamicCDFDocument(new jsx3.net.URI("http://isocat:8080/isocat/rest/info/rule-types.xml"),"RuleTypes2CDF_xsl",null,cacheId);
		this.ruleTypeMask.setXMLId(cacheId);
		
		// reset more of the form
		//this.newDataCategory();

		org.isocat.gui.DCEditor.log.info("initialized DC editor["+this+"]");
		
		this.view.controller = this;
		
		// publish the message using PageBus
		org.isocat.publish("org.isocat.gui.DCEditor.init", this);
	};
	
	DCEditor_prototype.dcId = function() {
		var id = this.view.getId();
		if (typeof(this.dc) != 'undefined')
			id = this.dc.id;
		return "dc-"+id;
	};
	
	DCEditor_prototype.cacheId = function() {
		return "DC-"+this.dcId();
	};
	
	DCEditor_prototype.newDataCategory = function(addToBasket) {
	    if (typeof(addToBasket) == 'undefined')
	        this.addToBasket = false;
	    else
	        this.addToBasket = addToBasket;
		this.editDataCategory();
	};
	
	DCEditor_prototype.editDataCategory = function(dc) {
		org.isocat.gui.Loading.load(this.view,"Loading ...").show();

		this.dc = dc;
		
		var src = null;
		
		if (typeof(dc) == 'undefined') {
			org.isocat.gui.DCEditor.log.info("editing new DC");
			src = "dc_xml";
			this.canCheck(false);
		} else {
			org.isocat.gui.DCEditor.log.info("editing existing DC["+dc.id+"]");
			
			if (!this.lockDataCategory()) {
				//this.close();
				return false;
			}
			
			// set the title
              		this.setTitle();
			
                        // disable the type field
			//this.type.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
	
			// load the DC content
			src = jsx3.net.URI.valueOf("http://isocat:8080/isocat/rest/dc/"+this.dc.id+".dcif?dcif-cleanup=false&parse-xml-constraints=false");
			
			// we can check an existing DC
			this.checkIcon();
			this.canCheck(true);
		}
		
		this.check(false);

		this.checks = new Object();

		if (src != null) {
			org.isocat.gui.DCEditor.log.info("load uri["+src+"].");
			org.isocat.loadDynamicCDFDocument(src,"DC2CDF_xsl",null,this.cacheId());
		
			// update the rest of the interface
			this.update();
		}
		
		return true;
	};
	
	DCEditor_prototype.lockDataCategory = function() {
		var locked = false;
		// acquire a lock on the DC
		var lock = org.isocat.profile.lockDC(this.dc.id);
		if (lock == null) {
			// there was an error in getting this lock, probably you can't edit this DC
			org.isocat.APP.alert("Can't edit this DC","Sorry, you can't edit this data category because you can't lock it.",null,"OK");
			this.lock = null;
		} else {
			var type = lock.selectSingleNode("/*").getNodeName();
			if (type == 'nolock') {
				// this DC is already locked
				var name = lock.selectSingleNode("/nolock/user").getValue();
				org.isocat.APP.alert("DC is already locked","Sorry, you can't edit this data category because it is locked by another user ("+name+").",null,"OK");
				this.lock = null;
			} else if (type == 'lock') {
				org.isocat.gui.DCEditor.log.info("acquired DC lock["+lock+"]");
				var id = lock.selectSingleNode("/lock/id").getValue();
				this.lock = {id:id};
				locked = true;
			} else {
				org.isocat.APP.alert("Can't edit this DC","An error occured and the data category couldn't be locked! Please contact the ISOcat system administrator.",null,"OK");
				this.lock = null;
			}
		}
		return locked;
	};
	
	DCEditor_prototype.update = function() {
		org.isocat.gui.DCEditor.log.info("update DC editor["+this+"] ...");
		
		// update the CDF data source
		this.cdf.setXMLId(this.cacheId());
		this.cdf.setCDFId(this.dcId());
		this.cdf.read(true);
		
		org.isocat.gui.DCEditor.log.info("updated the DC editor CDF source with cache["+this.cacheId()+"].");
				
		this.updateAdminInfo();
		this.updateDescrInfo();
		this.updateLingInfo();

		// reset buttons
		this.canSave(false);
		
		this.change = false;
		
		// reset the title
		this.setTitle();
		
		org.isocat.gui.Loading.load(this.view,"Loading ...").hide();
		
		org.isocat.gui.DCEditor.log.info("... update DC editor["+this+"]");
	};
	
	DCEditor_prototype.updateAdminInfo = function() {
		org.isocat.gui.DCEditor.log.info("update DC editor["+this+"] administrative information ...");

		var cdfDoc = this.cdf.getXML();
		
		// reset the DC type switch
		this.DCType = null;
		this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
		
		var cacheId = this.cacheId()+"-explanations";
		org.isocat.APP.getCache().setDocument(cacheId,org.isocat.createSubCDFDocument(cdfDoc,"explanations",true));
		this.explanations.setXMLId(cacheId);
		this.explanations.repaintData();

		cacheId = this.cacheId()+"-issues";
		org.isocat.APP.getCache().setDocument(cacheId,org.isocat.createSubCDFDocument(cdfDoc,"issues",true));
		this.issues.setXMLId(cacheId);
		this.issues.repaintData();

		org.isocat.gui.DCEditor.log.info("... update DC editor["+this+"] administrative information");
	};
	
	DCEditor_prototype.updateDescrInfo = function() {
		org.isocat.gui.DCEditor.log.info("update DC editor["+this+"] descriptive information ...");

		var cdfDoc = this.cdf.getXML();
		
		var profDoc = org.isocat.createSubCDFDocument(cdfDoc,"profiles",true);
		org.isocat.gui.DCEditor.log.info("profiles["+profDoc.getRecordIds().lenght+"]:"+profDoc);
		var profs = profDoc.getRecordIds();
		if (typeof(profs)=='undefined' || profs.length==0) {
		    this.setCheck("profiles","none");
		} else {
			for(var i=0;i<profs.length;i++) {
			     this.profiles.selectRecord(profs[i]);
			}
		    this.setCheck("profiles","ok");
		    this.profiles.revealRecord(profs[0]);
		    this.profiles.repaintData();
            
            org.isocat.gui.DCEditor.log.info("revealed profile["+profs[0]+"]?");
		}

		var cacheId = this.cacheId()+"-datanames";
		org.isocat.APP.getCache().setDocument(cacheId,org.isocat.createSubCDFDocument(cdfDoc,"datanames",true));
		this.dataElementNames.setXMLId(cacheId);
		this.dataElementNames.repaintData();
		
		this.languageSectionLeft.reset();
		this.languageSectionRight.reset();
		
		// check the existing language sections
		var langs = this.langsLeft.getRecordIds();
		for(var i=0;i<langs.length;i++) {
			var lang = this.langsLeft.getRecordNode(langs[i]);
			var tag  = lang.getAttribute("tag");
			var lsec = cdfDoc.selectSingleNode("//record[@jsxid='languagesections']/record[@jsxtext='"+tag+"']");
			//org.isocat.gui.DCEditor.log.info("- language section["+tag+"]:"+(lsec!=null?"1":"0"));
			lang.setAttribute("jsxselected",(lsec!=null?"1":"0"))
			lang = this.langsRight.getRecordNode(langs[i]);
			lang.setAttribute("jsxselected",(lsec!=null?"1":"0"))
		}

		// select the english language section, if it exists
		var english = this.langsLeft.selectSingleNode("//record[@tag='en']");
		if (english!=null) {
			this.selectLanguageSection(this.languageMenuLeft,english);
		} else {
			org.isocat.gui.DCEditor.log.info("... no english?");
			this.selectLanguageSection(this.languageMenuLeft,this.langsLeft.selectSingleNode("//record[@tag]"));
		}
		
		this.selectLanguageSection(this.languageMenuRight,this.langsRight.selectSingleNode("//record[@jsxid='none']"));

		org.isocat.gui.DCEditor.log.info("... update DC editor["+this+"] descriptive information");
	};
	
	DCEditor_prototype.updateLingInfo = function() {
		org.isocat.gui.DCEditor.log.info("update DC editor["+this+"] linguistic information ...");
		
		var cdfDoc = this.cdf.getXML();
		
		var dcType = this.cdf.getXML().getRecord("admin").type;
		if (dcType === null)
			dcType = "complex";
		var cdType = this.cdf.getXML().getRecord("conceptualdomain").type;
		if (cdType === null)
			cdType = "open";
		
		// complex DC: data type
		var datatype = cdfDoc.getRecordNode("conceptualdomain").getAttribute("datatype-id");
		if (datatype === null)
			datatype = "datatype-1"; // the id of the default data type: string
		this.datatypes.setValue(datatype);
		
		// when this.datatypes is a tree
		//this.datatypes.selectRecord("datatype-1");
		//var par = this.datatypes.getRecordNode("datatype-1").getParent();
		//while (par.getNodeName()=='record') {
		//	par.setAttribute("jsxopen","1");
		//	par = par.getParent();
		//}

		// closed DC: value domain
		var cacheId = this.cacheId()+"-valuedomain";
		if (cdType == "closed") {
			org.isocat.APP.getCache().setDocument(cacheId,org.isocat.createSubCDFDocument(cdfDoc,"conceptualdomain",true));
		} else {
			org.isocat.APP.getCache().setDocument(cacheId,new jsx3.xml.CDF.Document.newDocument()); // an empty CDF document
		}
		this.valueDomain.setProfiles(this.getProfiles());
		this.valueDomain.setValues(cacheId);
		
		// constrained DC: constraints
		var cacheId = this.cacheId()+"-constraints";
		if (cdType == "constrained") {
			org.isocat.APP.getCache().setDocument(cacheId,org.isocat.createSubCDFDocument(cdfDoc,"conceptualdomain",true));
		} else {
			org.isocat.APP.getCache().setDocument(cacheId,new jsx3.xml.CDF.Document.newDocument()); // an empty CDF document
		}
		this.constraints.setXMLId(cacheId);
		this.constraints.repaintData();
		
		// simple DC
		this.isARecord = null;
		if (dcType == "simple") {
			this.isARecord = this.cdf.getXML().getRecord("is-a");
			this.updateIsA();
		}
		
		this.linguisticSectionLeft.reset();
		this.linguisticSectionRight.reset();
		
		// check the existing linguistic sections
		var langs = this.lingsLeft.getRecordIds();
		for(var i=0;i<langs.length;i++) {
			var lang = this.lingsLeft.getRecordNode(langs[i]);
			var tag  = lang.getAttribute("tag");
			var lsec = cdfDoc.selectSingleNode("//record[@jsxid='linguisticsections']/record[@jsxtext='"+tag+"']");
			//org.isocat.gui.DCEditor.log.info("- language section["+tag+"]:"+(lsec!=null?"1":"0"));
			lang.setAttribute("jsxselected",(lsec!=null?"1":"0"))
			lang = this.lingsRight.getRecordNode(langs[i]);
			lang.setAttribute("jsxselected",(lsec!=null?"1":"0"))
		}

		this.selectLinguisticSection(this.linguisticMenuLeft,this.lingsLeft.selectSingleNode("//record[@jsxid='none']"));
		this.selectLinguisticSection(this.linguisticMenuRight,this.lingsRight.selectSingleNode("//record[@jsxid='none']"));
		
		org.isocat.gui.DCEditor.log.info("... update DC editor["+this+"] linguistic information");
	};
		
	DCEditor_prototype.updateLanguageMenu = function(menu,lang,repaint) {
		if (lang != "none") {
			var objRECORD = menu.getRecordNode(lang);
			menu.setText(objRECORD.getAttribute("jsxtext"));
			if (objRECORD.getAttribute("jsximg")!=null)
				menu.setImage(objRECORD.getAttribute("jsximg"));
			else
				menu.setImage("images/flag.png");
		} else {
			menu.setText("Language");
			menu.setImage("images/flag.png");
		}

		if (repaint)
			menu.repaint();
	}

	DCEditor_prototype.syncLanguageSectionsMenus = function(src,lang,repaint) {
		var dst = null;
		if (src == this.languageMenuLeft)
			dst = this.languageMenuRight;
		else
			dst = this.languageMenuLeft;
		
		org.isocat.gui.DCEditor.log.info("DCEditor.syncLanguageSectionsMenus:src["+src+"]dst["+dst+"]lang["+lang+"]");

		var langs = dst.getRecordIds();
		for(var i=0;i<langs.length;i++)
			if (langs[i] == lang)
				dst.getRecordNode(lang).setAttribute("jsxdisabled","1"); // disable the selected lang in the src menu in the dst menu
			else
				dst.getRecordNode(langs[i]).setAttribute("jsxdisabled","0");
		
		if (repaint)
			dst.repaint();
	};

	DCEditor_prototype.selectLanguageSection = function(menu,lang) {
		var langid = lang.getAttribute("jsxid");
		this.updateLanguageMenu(menu,langid,false);
		this.syncLanguageSectionsMenus(menu,langid,false);
		
		// save the previously selected language section (if it has changed)
		var saved = null;
		if (menu == this.languageMenuRight) {
			if (this.languageSectionRight.save(false))
				saved = this.languageSectionRight.lang;
		} else {
			if (this.languageSectionLeft.save(false))
				saved = this.languageSectionLeft.lang;
		}

		// check the saved language section in the menus
		if (saved!=null) {
			this.langsLeft.getRecordNode(saved.getAttribute("jsxid")).setAttribute("jsxselected","1");
			this.langsRight.getRecordNode(saved.getAttribute("jsxid")).setAttribute("jsxselected","1");
		}

		this.languageMenuRight.repaint();
		this.languageMenuLeft.repaint();
		
		if (langid!="none") {
			if (menu == this.languageMenuRight) {
				if (this.languageSectionsSplitter.getSubcontainer1Pct() == "100") {
					this.languageSectionsSplitter.setSubcontainer1Pct("50",true);
				}
			} else {
				if (this.languageSectionsSplitter.getSubcontainer1Pct() == "0") {
					this.languageSectionsSplitter.setSubcontainer1Pct("50",true);
				}
			}
			
			this.showLanguageSection(menu,lang);
		} else {
			if (menu == this.languageMenuRight) {
				if (this.languageSectionsSplitter.getSubcontainer1Pct() != "100")
					this.languageSectionsSplitter.setSubcontainer1Pct("100",true);
				this.languageSectionRight.reset();
				this.languageSectionRight.disable();
			} else {
				if (this.languageSectionsSplitter.getSubcontainer1Pct() != "0")
					this.languageSectionsSplitter.setSubcontainer1Pct("0",true);
				this.languageSectionLeft.reset();
				this.languageSectionLeft.disable();
			}
		}
	};
	
	DCEditor_prototype.showLanguageSection = function(src,lang) {
		var dst = null;
		if (src == this.languageMenuLeft)
			dst = this.languageSectionLeft;
		else
			dst = this.languageSectionRight;
		
		var lsec = this.cdf.getXML().selectSingleNode("//record[@jsxid='languagesections']/record[@language='"+lang.getAttribute("jsxid")+"']");
		org.isocat.gui.DCEditor.log.info("DCEditor.showLanguageSection(src["+src+"]dst["+dst+"]lang["+lang+"]):lsec["+lsec+"]");
		
		dst.enable();
		if (lsec!=null) {
			// use the existing one
			dst.editLanguageSection(lang,lsec,this.cdf.getXML());
		} else {
			// check if a record with id 'languagesections' exists
			var ls = this.cdf.getXML().getRecordNode('languagesections');
			if (ls == null)
				this.cdf.getXML().insertRecord({jsxid:'languagesections'},this.dcId());
			// create a new one, and use that
			var id =  jsx3.xml.CDF.getKey();
			lsec = {jsxid:id, language:lang.getAttribute("jsxid"), jsxtext:lang.getAttribute("tag")};
			lsec = this.cdf.getXML().insertRecord(lsec,'languagesections',true);
			org.isocat.gui.DCEditor.log.info("DCEditor.showLanguageSection(...):added lsec["+id+"]["+lsec+"]");
			dst.editLanguageSection(lang,lsec,this.cdf.getXML());
		}
	};
	
	DCEditor_prototype.updateLinguisticMenu = function(menu,lang,repaint) {
		if (lang != "none") {
			var objRECORD = menu.getRecordNode(lang);
			menu.setText(objRECORD.getAttribute("jsxtext"));
			if (objRECORD.getAttribute("jsximg")!=null)
				menu.setImage(objRECORD.getAttribute("jsximg"));
			else
				menu.setImage("images/flag.png");
		} else {
			menu.setText("Language");
			menu.setImage("images/flag.png");
		}

		if (repaint)
			menu.repaint();
	}

	DCEditor_prototype.syncLinguisticSectionsMenus = function(src,lang,repaint) {
		var dst = null;
		if (src == this.linguisticMenuLeft)
			dst = this.linguisticMenuRight;
		else
			dst = this.linguisticMenuLeft;
		
		org.isocat.gui.DCEditor.log.info("DCEditor.syncLinguisticSectionsMenus:src["+src+"]dst["+dst+"]lang["+lang+"]");

		var langs = dst.getRecordIds();
		for(var i=0;i<langs.length;i++)
			if (langs[i] == lang)
				dst.getRecordNode(lang).setAttribute("jsxdisabled","1"); // disable the selected lang in the src menu in the dst menu
			else
				dst.getRecordNode(langs[i]).setAttribute("jsxdisabled","0");
		
		if (repaint)
			dst.repaint();
	};

	DCEditor_prototype.selectLinguisticSection = function(menu,lang) {
		var langid = lang.getAttribute("jsxid");
		this.updateLinguisticMenu(menu,langid,false);
		this.syncLinguisticSectionsMenus(menu,langid,false);
		
		// save the previously selected linguistic section (if it has changed)
		var saved = null;
		if (menu == this.linguisticMenuRight) {
			if (this.linguisticSectionRight.save(false))
				saved = this.linguisticSectionRight.lang;
		} else {
			if (this.linguisticSectionLeft.save(false))
				saved = this.linguisticSectionLeft.lang;
		}

		// check the saved linguistic section in the menus
		if (saved!=null) {
			this.lingsLeft.getRecordNode(saved.getAttribute("jsxid")).setAttribute("jsxselected","1");
			this.lingsRight.getRecordNode(saved.getAttribute("jsxid")).setAttribute("jsxselected","1");
		}

		this.linguisticMenuRight.repaint();
		this.linguisticMenuLeft.repaint();
		
		if (langid!="none") {
			if (menu == this.linguisticMenuRight) {
				if (this.linguisticSectionsSplitter.getSubcontainer1Pct() == "100") {
					this.linguisticSectionsSplitter.setSubcontainer1Pct("50",true);
				}
			} else {
				if (this.linguisticSectionsSplitter.getSubcontainer1Pct() == "0") {
					this.linguisticSectionsSplitter.setSubcontainer1Pct("50",true);
				}
			}
			
			this.showLinguisticSection(menu,lang);
		} else {
			if (menu == this.linguisticMenuRight) {
				if (this.linguisticSectionsSplitter.getSubcontainer1Pct() != "100")
					this.linguisticSectionsSplitter.setSubcontainer1Pct("100",true);
				this.linguisticSectionRight.reset();
				this.linguisticSectionRight.disable();
			} else {
				if (this.linguisticSectionsSplitter.getSubcontainer1Pct() != "0")
					this.linguisticSectionsSplitter.setSubcontainer1Pct("0",true);
				this.linguisticSectionLeft.reset();
				this.linguisticSectionLeft.disable();
			}
		}
	};
	
	DCEditor_prototype.showLinguisticSection = function(src,lang) {
		var dst = null;
		if (src == this.linguisticMenuLeft)
			dst = this.linguisticSectionLeft;
		else
			dst = this.linguisticSectionRight;
		
		var lsec = this.cdf.getXML().selectSingleNode("//record[@jsxid='linguisticsections']/record[@language='"+lang.getAttribute("jsxid")+"']");
		org.isocat.gui.DCEditor.log.info("DCEditor.showLinguisticSection(src["+src+"]dst["+dst+"]lang["+lang+"]):lsec["+lsec+"]");
		
		dst.enable();
		if (lsec!=null) {
			// use the existing one
			dst.editLinguisticSection(lang,lsec,this.cdf.getXML());
		} else {
			// check if a record with id 'linguisticsections' exists
			var ls = this.cdf.getXML().getRecordNode('linguisticsections');
			if (ls == null)
				this.cdf.getXML().insertRecord({jsxid:'linguisticsections'},this.dcId());
			// create a new one, and use that
			var id =  jsx3.xml.CDF.getKey();
			lsec = {jsxid:id, language:lang.getAttribute("jsxid"), jsxtext:lang.getAttribute("tag"), type:dst.domainType };
			lsec = this.cdf.getXML().insertRecord(lsec,'linguisticsections',true);
			org.isocat.gui.DCEditor.log.info("DCEditor.showLinguisticSection(...):added lsec["+id+"]["+lsec+"]");
			dst.editLinguisticSection(lang,lsec,this.cdf.getXML());
		}
	};
	
	DCEditor_prototype.addExplanation = function() {
		var id =  jsx3.xml.CDF.getKey();
		var rec = this.explanations.insertRecord({jsxid:id,jsxtext:''});
		jsx3.sleep(function() { this.explanations.focusCellById(id,"jsxtext"); },"focusCell",this,true);
		this.changed();
	};
	
	DCEditor_prototype.addIssue = function() {
		var id =  jsx3.xml.CDF.getKey();
		var rec = this.issues.insertRecord({jsxid:id,jsxtext:''});
		jsx3.sleep(function() { this.issues.focusCellById(id,"jsxtext"); },"focusCell",this,true);
		this.changed();
	};
	
	DCEditor_prototype.addDataElementName = function() {
		var id =  jsx3.xml.CDF.getKey();
		var rec = this.dataElementNames.insertRecord({jsxid:id,jsxtext:'',source:''});
		jsx3.sleep(function() { this.dataElementNames.focusCellById(id,"jsxtext"); },"focusCell",this,true);
		this.changed();
	};
	
	DCEditor_prototype.addConstraint = function() {
		var id =  jsx3.xml.CDF.getKey();
		var rec = this.constraints.insertRecord({jsxid:id,jsxtext:''});
		jsx3.sleep(function() { this.constraints.focusCellById(id,"jsxtext"); },"focusCell",this,true);
		this.changed();
	};
	
	DCEditor_prototype.profilesChanged = function() {
		// callback from the ProfilesInput
		var profDoc = this.getProfiles();
	    org.isocat.gui.DCEditor.log.info("DCEditor.profilesChanged():profs["+profDoc+"]");
		// update profile check
		var profs = profDoc.getRecordIds();
		if (typeof(profs)=='undefined' || profs.length==0) {
		    this.setCheck("profiles","none");
    		org.isocat.APP.alert("Profile membership","A data category should be a member of at least one profile!",null,"OK");

		} else {
		    this.setCheck("profiles","ok");
		}
		// propagate changes to the ProfileValueDomainEditor
		this.valueDomain.setProfiles(profDoc,this.valueDomain.hasValues());
		// trigger changed
		this.changed();
	};
	
	DCEditor_prototype.getProfiles = function() {
	    var profs = new jsx3.xml.CDF.Document();
	    profs.createDocumentElement("data");
		profs.setAttribute("jsxid","jsxroot");
        for (var iter = this.profiles.getSelectedNodes().iterator();iter.hasNext();) {
            var prof = iter.next();
			prof = prof.cloneNode(true);
			prof.removeChildren();
			prof.removeAttribute("checked");
			prof.removeAttribute("jsxopen");
			profs.appendChild(prof);
        }
        return profs;
	};
		
	DCEditor_prototype.delValue = function(id) {
		// signal the linguistic sections
		var vid = id.replace(/.*-/,'');
		for (var langs = this.cdf.getXML().selectNodeIterator("//record[@jsxid='linguisticsections']/record/@jsxtext");langs.hasNext();) {
			var lang = langs.next().getValue();
			var val  = "lingsec-conceptualdomain-"+lang+"-value-"+vid;
			var rec  = this.cdf.deleteRecord(val,false);
			if (rec != null)
				org.isocat.gui.DCEditor.log.info("value["+val+"] deleted from LS["+lang+"]");
		}
		this.linguisticSectionLeft.delValue(vid);
		this.linguisticSectionRight.delValue(vid);
	};
	
	DCEditor_prototype.getValues = function() {
		return this.valueDomain.getValues();
	};
	
	DCEditor_prototype.editIsA = function() {
		 var list = org.isocat.APP.getRootBlock().loadAndCache("components/DCList.xml",true).controller;
		 list.setSingleSelect();
		 if (this.isARecord != null) {
			 var values = new Array(1);
			 values[0] = this.isARecord.id;
			 list.preselectValues(new jsx3.util.List(values));
		 }
		 
		 //check if the DC is member of the private profile
		 var q = null;
		 if ((this.profiles.getProfiles().getRecord("profile-0")!=null)) {
			 // any simple DC can be linked
			 q = new org.isocat.data.Query(org.isocat.profile.user(),"simple",new Array());
			 org.isocat.gui.DCEditor.log.info("DCEditor.editIsA():query for any simple DC");
		 } else {
			 // only simple DCs from the selected profiles can be linked
			 q = new org.isocat.data.Query(org.isocat.profile.user(),"simple",this.profiles.getProfiles().getRecordIds());
			 org.isocat.gui.DCEditor.log.info("EDEditor.editIsA():query for simple DCs belonging to selected profiles");
		 }
		 
		 list.callback(this,this.setIsA);
		 list.load(q);
	};

	DCEditor_prototype.setIsA = function(values) {
		var dc = values.get(0);
		if (dc != null) {
			// need the following CDF record: @jsxid='is-a' @id=<id> @jsxtext=<name> @name=<name> identifier=<identifier>
			if (dc.getAttribute("id")!="0") {
				this.isARecord = {jsxid:"is-a",id:dc.getAttribute("id"),jsxtext:dc.getAttribute("name"),name:dc.getAttribute("name"),identifier:dc.getAttribute("identifier")};
				this.updateIsA();
				org.isocat.gui.DCEditor.log.info("simple DC ["+this+"] is a is ["+this.isARecord.id+","+this.isARecord.jsxtext+"]");
			} else {
				this.deleteIsA();
			}
		}
		return true;
	};
	
	DCEditor_prototype.deleteIsA = function() {
		this.isARecord = null;
		this.updateIsA();
		org.isocat.gui.DCEditor.log.info("simple DC ["+this+"] is a set to none");
		this.changed();
	};
	
	DCEditor_prototype.updateIsA = function() {
		var text="<i>none</i>";
		if (this.isARecord != null) {
			var text = "/"+this.isARecord.identifier+"/";
			if (this.isARecord.identifier != this.isARecord.name)
				text += " ("+this.isARecord.name+")";
		}
		this.isA.setText(text,true);
    	this.changed();
	};
	
	DCEditor_prototype.changed = function() {
		this.change = true;
		this.setTitle();
		this.canSave(true);
		this.canCheck(false);
	};
	
	DCEditor_prototype.changedType = function() {
		var type = this.type.getValue();
		this.changed();
		this.setDCType(type);
		
		org.isocat.gui.DCEditor.log.info("DCEditor: old type["+this.DCType+"] new type["+type+"]");
		
		var icon = this.typeChangeInfo.getChild("image");
		var text = this.typeChangeInfo.getChild("label");
		if (this.DCType != type) {
			if (this.DCType=='closed') {
				this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
				icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-warning.png");
				icon.repaint();
				text.setText("value domains will be deleted",true);
			} else if (this.DCType=='constrained') {
				this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
				icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-warning.png");
				icon.repaint();
				text.setText("constraints will be deleted",true);
			} else if (this.DCType=='simple') {
				this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
				icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-warning.png");
				icon.repaint();
				text.setText("value domain relationships will be deleted",true);
			} else {
				this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
			}
		} else {
			this.typeChangeInfo.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
		}
	};
	
	DCEditor_prototype.setDCType = function(type) {
		if (this.DCType == null)
			this.DCType = type;
		if (type == 'container') {
			org.isocat.gui.DCEditor.log.info("container DC");
			this.simpleComplexTabs.setSelectedIndex(2,true);
		} else if (type == 'simple') {
			org.isocat.gui.DCEditor.log.info("simple DC");
			this.simpleComplexTabs.setSelectedIndex(0,true);
		} else {
			this.simpleComplexTabs.setSelectedIndex(1,true);
			org.isocat.gui.DCEditor.log.info("complex DC");
			if (type == 'open') {
				this.closedConstrainedTabs.setVisibility(jsx3.gui.Block.VISIBILITYHIDDEN,true);
				org.isocat.gui.DCEditor.log.info("open complex DC");
			} else {
				this.closedConstrainedTabs.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
				if (type == 'closed') {
					this.closedConstrainedTabs.setSelectedIndex(0,true);
					org.isocat.gui.DCEditor.log.info("closed complex DC");
				} else {
					this.closedConstrainedTabs.setSelectedIndex(1,true);
					org.isocat.gui.DCEditor.log.info("constrained complex DC");
				}
			}
		}
		this.linguisticSectionLeft.setDCType(type);
		this.linguisticSectionRight.setDCType(type);
	};
	
	DCEditor_prototype.canSave = function(enable) {
		org.isocat.gui.DCEditor.log.info("DCEditor.canSave("+enable+")");
	        if (enable) {
		    if (this.identifier.getValue()=='') {
		    	org.isocat.gui.DCEditor.log.info("DCEditor.canSave(...):empty identifier");
	                enable = false;
	            }
	            if (this.type.getValue()=='') {
		    	org.isocat.gui.DCEditor.log.info("DCEditor.canSave(...):empty type");
	                enable = false;
	            }
		    if (this.anyError()) {
		    	org.isocat.gui.DCEditor.log.info("DCEditor.canSave(...):some error");
			enable = false;
		    }
	        }
		org.isocat.gui.DCEditor.log.info("DCEditor.canSave(...):enable["+enable+"]");
	        
		if (enable) {
			this.saveButtonMenu.setEnabled(jsx3.gui.Form.STATEENABLED,true);
			this.saveButtonWizard.setEnabled(jsx3.gui.Form.STATEENABLED,true);
		} else {
			this.saveButtonMenu.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
			this.saveButtonWizard.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
		}
	};
	
	DCEditor_prototype.canCheck = function(enable) {
		if (enable) {
			this.checkButton.setEnabled(jsx3.gui.Form.STATEENABLED,true);
		} else {
			this.checkButton.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
		}
	};
	
	DCEditor_prototype.checkIdentifier = function() {
		var icon = this.identifierCheckInfo.getChild("image");
		var text = this.identifierCheckInfo.getChild("label");
		icon.setSrc("http://isocat:8080/famfamfam/silk/icons/hourglass.png");
		icon.repaint();
		text.setText("checking ...",true);
		this.identifierCheckInfo.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
		this.identifier.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
		this.canSave(false);
		if (org.isocat.trim(this.identifier.getValue())!='') {
			var url = "http://isocat:8080/isocat/rest/user/"+escape(org.isocat.profile.user())+"/search.xml?fields=identifier&scope=both&keywords="+escape(this.identifier.getValue());
			org.isocat.asyncLoadDocument(url,null,this,this.checkedIdentifier);
			this.setCheck("identifier","checking");
		} else {
			org.isocat.gui.DCEditor.log.info("identifier is empty");
			icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-error.png");
			icon.repaint();
			text.setText("identifier is empty",true);
			this.setCheck("identifier","empty");
		}
	};
	
	DCEditor_prototype.checkedIdentifier = function(doc,req) {
		this.identifier.setEnabled(jsx3.gui.Form.STATEENABLED,true);
		var icon = this.identifierCheckInfo.getChild("image");
		var text = this.identifierCheckInfo.getChild("label");
		if (doc != null) {
			org.isocat.gui.DCEditor.log.info("checked identifier["+doc+"].");
			var cid = 0;
			if (typeof(this.dc)!='undefined')
				cid = this.dc.id;
			var uid = org.isocat.profile.id();
			if (typeof(this.dc)!='undefined')
				uid = this.dc.owner_id;
			// find DCs with the same name (owned by the logged in user)
			var xp = "//dc[identifier='"+this.identifier.getValue()+"'][owner/@id="+uid+"]";
			var ids = doc.selectNodes(xp);
			org.isocat.gui.DCEditor.log.info("found ids["+ids.size()+"].");
			if (ids.size()==0) {
				// doesn't exist yet
				org.isocat.gui.DCEditor.log.info("owner/identifier combo doesn't exist yet");
				icon.setSrc("http://isocat:8080/famfamfam/silk/icons/tick.png");
				icon.repaint();
				text.setText("",true);
				this.setCheck("identifier","ok");
				this.canSave(true);
				// if there are public (TODO: shared) matches suggest those
				xp = "//dc[identifier='"+this.identifier.getValue()+"'][scope='public']";
				ids = doc.selectNodes(xp);
				if (ids.size()==1) {
					var dup = doc.selectSingleNode(xp);
					var msg = "Maybe this data category already exists. Can it be this public one?";
					msg += "<p>";
					msg += '<a href="#" onclick="javascript:org.isocat.showDataCategoryInWindow(\''+dup.selectSingleNode("id").getValue()+'\')">'+dup.selectSingleNode("name").getValue()+'</a>';
					msg += "</p>";
					org.isocat.APP.alert("Data Category suggestion",msg,null,"Close",{nonModal:true});
				} else if (ids.size()>1) {
					var msg = "Maybe this data category already exists. Can it be one of those, which are public available?";
					msg += "<ol>";
					for (var iter = ids.iterator();iter.hasNext();) {
						var dup = iter.next();
						msg += '<li><a href="#" onclick="javascript:org.isocat.showDataCategoryInWindow(\''+dup.selectSingleNode("id").getValue()+'\')">'+dup.selectSingleNode("name").getValue()+'</a></li>';
					}
					msg += "</ol>";
					org.isocat.APP.alert("Data Category suggestions",msg,null,"Close",{nonModal:true});
				} else if (ids.size()==0) {
					// check if the identifier is a valid local QName
					var xml = "<"+this.identifier.getValue()+"/>";
					var xdoc = new jsx3.xml.Document();
					xdoc.loadXML(xml);
					var err =  xdoc.getError();
					if (err.code != 0) {
						org.isocat.gui.DCEditor.log.info("XML check failed for identifier: "+err.description);
						icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-error.png");
						icon.repaint();
						text.setText("identifier is invalid",true);
						this.setCheck("identifier","invalid XML");
						this.canSave(false);
						org.isocat.APP.alert("This identifier is invalid","An identifier should be a valid local part of a qualified name as specified in the XML standard! This means, for example, that it isn't allowed to start with a number or to contain any spaces. You won't be able to save this (new) data category.",null,"OK");
					}
				}
			} else {
				// check if this DC is in the set
				var member = false;
				for (var iter = ids.iterator();iter.hasNext();) {
					if (iter.next().selectSingleNode("id").getValue() == cid) {
						member = true;
						break;
					}
				}
			        if (!member) {
					org.isocat.gui.DCEditor.log.info("owner/identifier combo does exist already");
					icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-warning.png");
					icon.repaint();
					text.setText("identifier already in use",true);
					var msg = "The registry already contains " + (ids.size()==1?"a data category":"data categories") +" with this identifier and owned by you:";
					msg += "<ol>";
					for (var iter = ids.iterator();iter.hasNext();) {
						var dup = iter.next();
						msg += '<li><a href="#" onclick="javascript:org.isocat.showDataCategoryInWindow(\''+dup.selectSingleNode("id").getValue()+'\')">'+dup.selectSingleNode("name").getValue()+'</a></li>';
					}
					msg += "</ol>";
					org.isocat.APP.alert("Data Category is known",msg,null,"OK",{nonModal:true});
					this.setCheck("identifier","ok");
					this.canSave(true);
				} else {
					org.isocat.gui.DCEditor.log.info("found dc.id["+cid+"]");
					icon.setSrc("http://isocat:8080/famfamfam/silk/icons/tick.png");
					icon.repaint();
					text.setText("",true);
					this.setCheck("identifier","ok");
					this.canSave(true);
				}
			}
		} else {
			org.isocat.gui.DCEditor.log.info("failed to check identifier");
			icon.setSrc("http://isocat:8080/Tango/16x16/status/dialog-error.png");
			icon.repaint();
			text.setText("couldn't validate the indentifier",true);
			this.setCheck("identifier","failed");
			this.canSave(false);
			org.isocat.APP.alert("Error validating identifier","An error occurred while validating the identifier! You won't be able to save this new data category. Please contact the system administrator.",null,"OK");
		}
	};
	
	DCEditor_prototype.checkConstraint = function(matrix,id,col,value) {
		var res = true;
		
		var attr = col.getPath();
		org.isocat.gui.DCEditor.log.info("column["+attr+"]");

		var session = null;
		if (id=="jsxautorow") {
			session = matrix.getAutoRowSession();
			org.isocat.gui.DCEditor.log.info("autorow["+session+"]");
		} else {
			session = matrix.getRecord(id);
			org.isocat.gui.DCEditor.log.info("rec["+session+"]");
		}

		var rtype = session["rule-type"];
		var rule  = session["jsxtext"];
		if (attr == "rule-type")
			rtype = value;
		if (attr == "jsxtext")
			rule = value;
		org.isocat.gui.DCEditor.log.info("rule-type["+rtype+"] rule["+rule+"]");
		
		if ((attr == "jsxtext") || (attr == "rule-type")) { // only check when the rule type or the rule changed
			if ((typeof(rtype)!='undefined') && (typeof(rule)!='undefined')) {
				var rid = this.ruleTypeMask.getXML().selectSingleNode("//record[@jsxtext='"+rtype+"']/@jsxid").getValue();
				var rec = this.ruleTypeMask.getRecord(rid);
				org.isocat.gui.DCEditor.log.info("rule-type["+rtype+"] needs XML["+(rec.xml=='true')+"]");
				
				if (rec.xml=='true') {
					var xdoc = new jsx3.xml.Document();
					xdoc.loadXML(rule);
					var err =  xdoc.getError();
					if (err.code != 0) {
						res = false;
						org.isocat.gui.DCEditor.log.info("XML check failed for rule["+rule+"]: "+err.description);
						org.isocat.APP.alert("This rule is invalid","A rule of type '"+rtype+"' needs to be wellformed XML! The XML parser reported the following error: <p>"+err.description+"</p> Due to this error you won't be able to save this (new) data category.",null,"OK");
						this.setCheck("constraint-"+session["jsxid"],"invalid-XML");
					} else {
						org.isocat.gui.DCEditor.log.info("XML check succeeded for rule["+rule+"]");
						this.setCheck("constraint-"+session["jsxid"],"ok");
					}
				} else
					this.setCheck("constraint-"+session["jsxid"],"ok"); // free text constraints are always ok
			}
		}
		
		this.canSave(res);
		return res;
	};

	DCEditor_prototype.setCheck = function(id,status) {
		this.checks[id] = status;
		org.isocat.gui.DCEditor.log.info("check["+id+"]:"+this.checks[id]);
	};

	DCEditor_prototype.anyError = function() {
		var res = false;
		for (check in this.checks) {
			if (this.checks[check] != "ok") {
				org.isocat.gui.DCEditor.log.info("check error["+check+"]:"+this.checks[check]);
				res = true;
				//break;
			}
		}
		return res;
	};
	
	DCEditor_prototype.save = function() {
		var saveDC = org.isocat.APP.getRootBlock().loadAndCache("components/SaveDC.xml",true);
		if (typeof(this.dc) == 'undefined')
			saveDC.controller.setType("CREATE");
		saveDC.controller.callback(this,this._save);
		saveDC.repaint();
		saveDC.controller.focus();
	};
	
	DCEditor_prototype._save = function(change) {
		this.cdf.write();
		org.isocat.gui.DCEditor.log.info("Synced CDF source with cache["+this.cacheId()+"].");
		
		//assemble the complete CDF document again
		var cdfDoc = this.cdf.getXML();
		org.isocat.replaceSubCDFDocument(cdfDoc,"admin","explanations",this.explanations.getXML(),true);
		org.isocat.replaceSubCDFDocument(cdfDoc,"admin","issues",this.issues.getXML(),true);
		org.isocat.replaceSubCDFDocument(cdfDoc,"descr","profiles",this.profiles.getProfiles(),true);
		org.isocat.replaceSubCDFDocument(cdfDoc,"descr","datanames",this.dataElementNames.getXML(),true);
		
		// save active language sections
		this.languageSectionLeft.save(false);
		this.languageSectionRight.save(false);
		
		// save conceptual domain
		var type = this.type.getValue()
		if (type != 'simple') {
			if (type == 'closed') {
				org.isocat.replaceSubCDFDocument(cdfDoc,"dc-"+(typeof(this.dc) == 'undefined'?0:this.dc.id),"conceptualdomain",this.valueDomain.getValues(),true);
			}  else if (type == 'constrained') {
				org.isocat.replaceSubCDFDocument(cdfDoc,"dc-"+(typeof(this.dc) == 'undefined'?0:this.dc.id),"conceptualdomain",this.constraints.getXML(),true);
			}
			var cd = cdfDoc.getRecordNode("conceptualdomain");
			cd.setAttribute("type",type);
			cd.setAttribute("datatype",this.datatypes.getRecord(this.datatypes.getValue()).jsxtext);
			cd.setAttribute("datatype-id",this.datatypes.getValue());
		}
		
		// save the simple DC isA relation
		if (this.isARecord != null) {
			cdfDoc.insertRecord(this.isARecord,"dc-"+(typeof(this.dc) == 'undefined'?0:this.dc.id));
		} else {
			// remove any existing isA record in the CDF doc
			cdfDoc.deleteRecord("is-a");
		}
		
		// save active language sections
		this.linguisticSectionLeft.save(false);
		this.linguisticSectionRight.save(false);
		
		// get the change document
		var changes = org.isocat.createSubCDFDocument(cdfDoc,"changes",true);
		changes.insertRecord({jsxid:jsx3.xml.CDF.getKey(), jsxtext:change});
		org.isocat.replaceSubCDFDocument(cdfDoc,"admin","changes",changes,true);
		
		// remove all autorow records
		var autorow = null;
		do {
			autorow = cdfDoc.deleteRecord("jsxautorow");
		} while (autorow != null);
		
		// convert the CDF document to DCIF
		var dcifDoc = org.isocat.transformXML(cdfDoc,"CDF2DC_xsl");
		if (dcifDoc == null) {
			org.isocat.gui.DCEditor.log.info("org.isocat.gui.DCEditor.save("+this.cacheId()+"):failed to transform!");
			org.isocat.APP.alert("Saving the Data Category failed","The DC couldn't be saved! Contact the ISOcat system administrator.",null,"OK");
			this.canSave(false);
			return;
		}

		var uri = "http://isocat:8080/isocat/rest";
		if (typeof(this.dc) == 'undefined') {
			uri += "/dc";
		} else {
			uri += "/user/"+escape(org.isocat.profile.user());
			uri += "/session/"+escape(org.isocat.profile.session().id);
			uri += "/lock/"+escape(this.lock.id);
			uri += "/dc/"+escape(this.dc.id);
		}
				
		var method = "POST";
		if (typeof(this.dc) == 'undefined')
			method = "PUT";
				
		org.isocat.gui.DCEditor.log.info("accessing service uri["+uri+"]["+method+"]["+dcifDoc+"]");
		
		//var req = new jsx3.net.Request().open(method,uri,false,org.isocat.profile.user(),org.isocat.profile.pass());
		var req = new jsx3.net.Request().open(method,uri,false);
		req.setRequestHeader("Content-Type","application/xml");// IE doesn't set this automagically (FF does), and otherwise NK won't pass it on to the ISOcat accessors
		req.setRequestHeader("Accept","application/x-dcif+xml");// we want the DCIF of the updated/new DC
		req.send(dcifDoc.toString());
		
		var status = req.getStatus();
		org.isocat.gui.DCEditor.log.info("service uri["+uri+"]["+method+"] returned HTTP status["+status+"]");
				
		if ((status==200) || (status==201)) {
			org.isocat.gui.DCEditor.log.info("service uri["+uri+"]["+method+"]["+status+"] response["+req.getResponseText()+"]");
			var dcifDoc = new jsx3.xml.Document();
			dcifDoc.loadXML(req.getResponseText());
			//org.isocat.gui.DCEditor.log.info("DC["+dcifDoc+"]");
			//var id = dcifDoc.selectSingleNode("/dcif:dataCategorySelection/dcif:dataCategory/@isocat:id",{dcif:'http://www.isocat.org/ns/dcif', isocat:'http://www.isocat.org/'}).getValue(); ... results in 'Multiple colons are not allowed in a name' error in IE
			var id = null;
			for (var iter = dcifDoc.getChildIterator();iter.hasNext();) {
			    var node = iter.next();
			    if (node.getBaseName() == 'dataCategory') {
			        id = node.getAttribute("isocat:id");
			    }
			}
			if (id==null)
			    org.isocat.APP.alert("Error","Sorry, the identity of this DC can't be determined! Please contact the ISOcat system administrator.",null,"OK")
			
			org.isocat.gui.DCEditor.log.info("DC["+dcifDoc+"]["+id+"]");
			
			if (typeof(this.dc) == 'undefined') {
			    // the DC now exists and has an id
			    this.dc = {id:id};
			    // and we now need a lock on it
			    if (!this.lockDataCategory())
				    this.close(); // this should be almost impossible ... the owner would have to quickly lock it in another browser window
			    // also rename the window
			    if (this.window != null)
				    this.window.setName("window-edit-DC-"+this.dc.id);
			    // ask if we need to add it to the basket
			    var view = this.view;
			    if (this.addToBasket) {
			        this.basket();
			    } else {
			        org.isocat.APP.confirm("Add to basket","Add this new Data Category to the basket?",
					    function(dialog) {
						    jsx3.GO(view.getId()).controller.basket(dialog);
					    },
					    null,"Yes","No",1);
			    }
			}
			
			// disable the type field, it can't be changed anymore
			//this.type.setEnabled(jsx3.gui.Form.STATEDISABLED,true);
			
			// convert the DCIF document to CDF
			var cdfDoc = org.isocat.transformXML(dcifDoc,"DC2CDF_xsl");
			cdfDoc = jsx3.xml.CDF.Document.wrap(cdfDoc);
			cdfDoc.convertProperties(org.isocat.APP.getProperties());
			
			// update the cached doc
			org.isocat.APP.getCache().setDocument(this.cacheId(),cdfDoc);

			// reload the form with the DCIF so we get all ids at the right places ... TODO: prevent that this resets all kind of UI elements ...
			this.update();
			
			// now we can check the DC
			this.canCheck(true);
			if (this.checkButton.getState()==jsx3.gui.ToolbarButton.STATEON) {
			    this.check(true);
			    org.isocat.gui.DCEditor.log.info("rechecked the DC");
			} else {
			    org.isocat.gui.DCEditor.log.info("skipped rechecking the DC");
			}
			
			// tell all listeners this DC is updated
			org.isocat.publish("org.isocat.DC.reload",this.dc.id);
		} else if (status==403) {
			org.isocat.APP.alert("Failed to save the DC","Sorry, you lost your edit lock on this DC.",null,"OK")
			org.isocat.gui.DCEditor.log.info("failed to save the DC["+org.isocat.profile.user()+"]["+this.identifier.getValue()+"]:status["+status+"]");
		} else if (status==409) {
			org.isocat.APP.alert("Failed to save the DC","Sorry, this DC already exists so the save failed.",null,"OK")
			org.isocat.gui.DCEditor.log.info("failed to save the DC["+org.isocat.profile.user()+"]["+this.identifier.getValue()+"]:status["+status+"]");
		} else {
			org.isocat.APP.alert("Failed to save the DC","Sorry, an error occurred on the server and the DC couldn't be saved.",null,"OK")
			org.isocat.gui.DCEditor.log.info("failed to save the DC["+org.isocat.profile.user()+"]["+this.identifier.getValue()+"]:status["+status+"]");
		}
		
		this.canSave(false);
		this.setTitle();
		return true;
	};
	
	DCEditor_prototype.basket = function(dialog) {
		var dc = org.isocat.data.DC.load(this.dc.id);
		org.isocat.addToBasket(dc);
		if (typeof(dialog)!='undefined') {
			dialog.doClose();
		}
	}

	DCEditor_prototype.cancel = function() {
		if (this.window != null) {
			var close = true;
			var view = this.view;
			if (this.change) {
				org.isocat.APP.confirm("Close this DC Editor","There are unsaved changes! Do you really want to close this editor?",
					function(dialog) {
						jsx3.GO(view.getId()).controller.close(dialog);
					},
					null,"Yes","No",2);
				close=false;
			}
			if (close)
				this.close();
		}
		return close;
	};
	
	DCEditor_prototype.close = function(dialog) {
		if (this.lock != null) {
			org.isocat.profile.unlockDC(this.lock.id);
		}
		if (this.window != null) {
			org.isocat.gui.DCEditor.log.info("this.window["+this.window+"].doClose() ...");
			this.window.doClose();
			org.isocat.gui.DCEditor.log.info("... done");
		}
		if (typeof(dialog)!='undefined') {
			dialog.doClose();
		}
	}

	DCEditor_prototype.check = function(show) {
		if (show) {
			// show the check result view
			if (this.viewSplitter.getSubcontainer1Pct() == "100") {
				this.viewSplitter.setSubcontainer1Pct("80",true);
			}
		
			// load the loading overlay
			org.isocat.gui.Loading.load(this.checkView,"Checking ...").show();

			// request the check
			var uri = "http://isocat:8080/isocat/rest/dc/"+this.dc.id+"/check"; 
			org.isocat.asyncLoadDynamicCDFDocument(new jsx3.net.URI(uri),"Check2CDF_xsl",null,"check-dc-"+this.dc.id,this,this.checked);
		} else {
			// hide the check result view
			if (this.viewSplitter.getSubcontainer1Pct() != "100") {
				this.viewSplitter.setSubcontainer1Pct("100",true);
			}
		}
	};
	
	DCEditor_prototype.checked = function(doc,req) {
		org.isocat.gui.Loading.load(this.checkView).hide();
		if (doc!=null) {
			this.checkResult.setXMLId("check-dc-"+this.dc.id);
			this.checkResult.repaintData();
		    
			// determine the check result
			this.dc.check = req.getResponseXML().selectSingleNode('/check/@result').getValue();
		    
			// update the check icon
			this.checkIcon();
		} else {
			// hide the check result view
			if (this.viewSplitter.getSubcontainer1Pct() != "100") {
				this.viewSplitter.setSubcontainer1Pct("100",true);
			}
			org.isocat.gui.DCViewer.log.info("The DC check call failed. The HTTP Status code is: " + req.getStatus());
			org.isocat.APP.alert("DC checking failed","The DC couldn't be checked! Contact the ISOcat system administrator.",null,"OK");
		}
	};
	
	DCEditor_prototype.checkIcon = function() {
                	// set the correct check icon
                	if (typeof(this.dc.check)!='undefined') {
                	    var prop = "icon: check "+this.dc.check;
                	    if (org.isocat.APP.getProperties().containsKey(prop)) {
                	        this.checkButton.setDynamicProperty("jsximage",prop,true)
                	        this.checkButton.repaint();
                                 }
                	}
	}
	
	DCEditor_prototype.setTitle =  function() {
		var title = "New Data Category";
		if (typeof(this.dc) != 'undefined')
			title = this.dc.name + " - " + this.dc.version;
		if (this.identifier.getValue() != '')
			title = this.identifier.getValue() + " - " + this.version.getValue();
		
		if (this.change)
			title += " *";
		
		org.isocat.gui.DCEditor.log.info("set DC editor title["+title+"].");
		
		if (this.window != null) {
			this.label.setText("",true);
			this.window.getCaptionBar().setText(title,true);
			//this.windowButton.setEnabled(jsx3.gui.Form.STATEDISABLED,true);;
		} else {
			this.label.setText(title,true);
			//this.windowButton.setEnabled(jsx3.gui.Form.STATEENABLED,true);;
		}
	};
	
	DCEditor_prototype.setWindow = function(window) {
		this.window = window;
		this.setTitle();
		this.cancelButtonWizard.setVisibility(jsx3.gui.Block.VISIBILITYVISIBLE,true);
		var close = this.window.getDescendantOfName("btnClose");
		// remove existing close button listeners
		close.unsubscribeAll(jsx3.gui.Interactive.EXECUTE);
		close.setEvent("",jsx3.gui.Interactive.EXECUTE);
		// register our own listener
		close.subscribe(jsx3.gui.Interactive.EXECUTE,this,this.cancel);
	};
	
	DCEditor_prototype.focus = function() {
		this.view.focus();

		jsx3.sleep(function() { this.identifier.focus(); },"focusDCEditor",this,true);
		org.isocat.gui.DCEditor.log.info("set DC editor focus to identifier field.");

		// delayed till everything is painted ...
		this.setDCType(this.cdf.getXML().getRecord("admin").type);
	};
});
